%ifndef __NASMX_CRYPT32_INC__
%define __NASMX_CRYPT32_INC__

IMPORT CertAddCRLContextToStore, 16
IMPORT CertAddCRLLinkToStore, 16
IMPORT CertAddCTLContextToStore, 16
IMPORT CertAddCTLLinkToStore, 16
IMPORT CertAddCertificateContextToStore, 16
IMPORT CertAddCertificateLinkToStore, 16
IMPORT CertAddEncodedCRLToStore, 24
IMPORT CertAddEncodedCTLToStore, 24
IMPORT CertAddEncodedCertificateToStore, 24
IMPORT CertAddEncodedCertificateToSystemStoreA, 12
IMPORT CertAddEncodedCertificateToSystemStoreW, 12
IMPORT CertAddEnhancedKeyUsageIdentifier, 8
IMPORT CertAddSerializedElementToStore, 32
IMPORT CertAddStoreToCollection, 16
IMPORT CertAlgIdToOID, 4
IMPORT CertCloseStore, 8
IMPORT CertCompareCertificate, 12
IMPORT CertCompareCertificateName, 12
IMPORT CertCompareIntegerBlob, 8
IMPORT CertComparePublicKeyInfo, 12
IMPORT CertControlStore, 16
IMPORT CertCreateCRLContext, 12
IMPORT CertCreateCTLContext, 12
IMPORT CertCreateCTLEntryFromCertificateContextProperties, 28
IMPORT CertCreateCertificateChainEngine, 8
IMPORT CertCreateCertificateContext, 12
IMPORT CertCreateContext, 24
IMPORT CertCreateSelfSignCertificate, 32
IMPORT CertDeleteCRLFromStore, 4
IMPORT CertDeleteCTLFromStore, 4
IMPORT CertDeleteCertificateFromStore, 4
IMPORT CertDuplicateCRLContext, 4
IMPORT CertDuplicateCTLContext, 4
IMPORT CertDuplicateCertificateChain, 4
IMPORT CertDuplicateCertificateContext, 4
IMPORT CertDuplicateStore, 4
IMPORT CertEnumCRLContextProperties, 8
IMPORT CertEnumCRLsInStore, 8
IMPORT CertEnumCTLContextProperties, 8
IMPORT CertEnumCTLsInStore, 8
IMPORT CertEnumCertificateContextProperties, 8
IMPORT CertEnumCertificatesInStore, 8
IMPORT CertEnumPhysicalStore, 16
IMPORT CertEnumSubjectInSortedCTL, 16
IMPORT CertEnumSystemStore, 16
IMPORT CertEnumSystemStoreLocation, 12
IMPORT CertFindAttribute, 12
IMPORT CertFindCRLInStore, 24
IMPORT CertFindCTLInStore, 24
IMPORT CertFindCertificateInCRL, 20
IMPORT CertFindCertificateInStore, 24
IMPORT CertFindChainInStore, 24
IMPORT CertFindExtension, 12
IMPORT CertFindRDNAttr, 8
IMPORT CertFindSubjectInCTL, 20
IMPORT CertFindSubjectInSortedCTL, 20
IMPORT CertFreeCRLContext, 4
IMPORT CertFreeCTLContext, 4
IMPORT CertFreeCertificateChain, 4
IMPORT CertFreeCertificateChainEngine, 4
IMPORT CertFreeCertificateContext, 4
IMPORT CertGetCRLContextProperty, 16
IMPORT CertGetCRLFromStore, 16
IMPORT CertGetCTLContextProperty, 16
IMPORT CertGetCertificateChain, 32
IMPORT CertGetCertificateContextProperty, 16
IMPORT CertGetEnhancedKeyUsage, 16
IMPORT CertGetIntendedKeyUsage, 16
IMPORT CertGetIssuerCertificateFromStore, 16
IMPORT CertGetNameStringA, 24
IMPORT CertGetNameStringW, 24
IMPORT CertGetPublicKeyLength, 8
IMPORT CertGetStoreProperty, 16
IMPORT CertGetSubjectCertificateFromStore, 12
IMPORT CertGetValidUsages, 20
IMPORT CertIsRDNAttrsInCertificateName, 16
IMPORT CertIsValidCRLForCertificate, 16
IMPORT CertNameToStrA, 20
IMPORT CertNameToStrW, 20
IMPORT CertOIDToAlgId, 4
IMPORT CertOpenStore, 20
IMPORT CertOpenSystemStoreA, 8
IMPORT CertOpenSystemStoreW, 8
IMPORT CertRDNValueToStrA, 16
IMPORT CertRDNValueToStrW, 16
IMPORT CertRegisterPhysicalStore, 20
IMPORT CertRegisterSystemStore, 16
IMPORT CertRemoveEnhancedKeyUsageIdentifier, 8
IMPORT CertRemoveStoreFromCollection, 8
IMPORT CertResyncCertificateChainEngine, 4
IMPORT CertSaveStore, 24
IMPORT CertSerializeCRLStoreElement, 16
IMPORT CertSerializeCTLStoreElement, 16
IMPORT CertSerializeCertificateStoreElement, 16
IMPORT CertSetCRLContextProperty, 16
IMPORT CertSetCTLContextProperty, 16
IMPORT CertSetCertificateContextPropertiesFromCTLEntry, 12
IMPORT CertSetCertificateContextProperty, 16
IMPORT CertSetEnhancedKeyUsage, 8
IMPORT CertSetStoreProperty, 16
IMPORT CertStrToNameA, 28
IMPORT CertStrToNameW, 28
IMPORT CertUnregisterPhysicalStore, 12
IMPORT CertUnregisterSystemStore, 8
IMPORT CertVerifyCRLRevocation, 16
IMPORT CertVerifyCRLTimeValidity, 8
IMPORT CertVerifyCTLUsage, 28
IMPORT CertVerifyCertificateChainPolicy, 16
IMPORT CertVerifyRevocation, 28
IMPORT CertVerifySubjectCertificateContext, 12
IMPORT CertVerifyTimeValidity, 8
IMPORT CertVerifyValidityNesting, 8
IMPORT CryptAcquireCertificatePrivateKey, 24
IMPORT CryptBinaryToStringA, 20
IMPORT CryptBinaryToStringW, 20
IMPORT CryptCloseAsyncHandle, 4
IMPORT CryptCreateAsyncHandle, 8
IMPORT CryptCreateKeyIdentifierFromCSP, 32
IMPORT CryptDecodeMessage, 52
IMPORT CryptDecodeObject, 28
IMPORT CryptDecodeObjectEx, 32
IMPORT CryptDecryptAndVerifyMessageSignature, 36
IMPORT CryptDecryptMessage, 24
IMPORT CryptEncodeObject, 20
IMPORT CryptEncodeObjectEx, 28
IMPORT CryptEncryptMessage, 28
IMPORT CryptEnumKeyIdentifierProperties, 28
IMPORT CryptEnumOIDFunction, 24
IMPORT CryptEnumOIDInfo, 16
IMPORT CryptExportPKCS8, 28
IMPORT CryptExportPublicKeyInfo, 20
IMPORT CryptExportPublicKeyInfoEx, 32
IMPORT CryptFindCertificateKeyProvInfo, 12
IMPORT CryptFindLocalizedName, 4
IMPORT CryptFindOIDInfo, 12
IMPORT CryptFormatObject, 36
IMPORT CryptFreeOIDFunctionAddress, 8
IMPORT CryptGetAsyncParam, 16
IMPORT CryptGetDefaultOIDDllList, 16
IMPORT CryptGetDefaultOIDFunctionAddress, 24
IMPORT CryptGetKeyIdentifierProperty, 28
IMPORT CryptGetMessageCertificates, 20
IMPORT CryptGetMessageSignerCount, 12
IMPORT CryptGetOIDFunctionAddress, 24
IMPORT CryptGetOIDFunctionValue, 28
IMPORT CryptHashCertificate, 28
IMPORT CryptHashMessage, 36
IMPORT CryptHashPublicKeyInfo, 28
IMPORT CryptHashToBeSigned, 24
IMPORT CryptImportPKCS8, 36
IMPORT CryptImportPublicKeyInfo, 16
IMPORT CryptImportPublicKeyInfoEx, 28
IMPORT CryptInitOIDFunctionSet, 8
IMPORT CryptInstallDefaultContext, 24
IMPORT CryptInstallOIDFunctionAddress, 24
IMPORT CryptLoadSip, 12
IMPORT CryptMemAlloc, 4
IMPORT CryptMemFree, 4
IMPORT CryptMemRealloc, 8
IMPORT CryptMsgCalculateEncodedLength, 24
IMPORT CryptMsgClose, 4
IMPORT CryptMsgControl, 16
IMPORT CryptMsgCountersign, 16
IMPORT CryptMsgCountersignEncoded, 28
IMPORT CryptMsgDuplicate, 4
IMPORT CryptMsgEncodeAndSignCTL, 24
IMPORT CryptMsgGetAndVerifySigner, 24
IMPORT CryptMsgGetParam, 20
IMPORT CryptMsgOpenToDecode, 24
IMPORT CryptMsgOpenToEncode, 24
IMPORT CryptMsgSignCTL, 28
IMPORT CryptMsgUpdate, 16
IMPORT CryptMsgVerifyCountersignatureEncoded, 28
IMPORT CryptMsgVerifyCountersignatureEncodedEx, 40
IMPORT CryptProtectData, 28
IMPORT CryptProtectMemory, 12
IMPORT CryptQueryObject, 44
IMPORT CryptRegisterDefaultOIDFunction, 16
IMPORT CryptRegisterOIDFunction, 20
IMPORT CryptRegisterOIDInfo, 8
IMPORT CryptSIPAddProvider, 4
IMPORT CryptSIPCreateIndirectData, 12
IMPORT CryptSIPGetSignedDataMsg, 20
IMPORT CryptSIPLoad, 12
IMPORT CryptSIPPutSignedDataMsg, 20
IMPORT CryptSIPRemoveProvider, 4
IMPORT CryptSIPRemoveSignedDataMsg, 8
IMPORT CryptSIPRetrieveSubjectGuid, 12
IMPORT CryptSIPRetrieveSubjectGuidForCatalogFile, 12
IMPORT CryptSIPVerifyIndirectData, 8
IMPORT CryptSetAsyncParam, 16
IMPORT CryptSetKeyIdentifierProperty, 24
IMPORT CryptSetOIDFunctionValue, 28
IMPORT CryptSignAndEncodeCertificate, 36
IMPORT CryptSignAndEncryptMessage, 32
IMPORT CryptSignCertificate, 36
IMPORT CryptSignMessage, 28
IMPORT CryptSignMessageWithKey, 20
IMPORT CryptStringToBinaryA, 28
IMPORT CryptStringToBinaryW, 28
IMPORT CryptUninstallDefaultContext, 12
IMPORT CryptUnprotectData, 28
IMPORT CryptUnprotectMemory, 12
IMPORT CryptUnregisterDefaultOIDFunction, 12
IMPORT CryptUnregisterOIDFunction, 12
IMPORT CryptUnregisterOIDInfo, 4
IMPORT CryptVerifyCertificateSignature, 20
IMPORT CryptVerifyCertificateSignatureEx, 32
IMPORT CryptVerifyDetachedMessageHash, 32
IMPORT CryptVerifyDetachedMessageSignature, 32
IMPORT CryptVerifyMessageHash, 28
IMPORT CryptVerifyMessageSignature, 28
IMPORT CryptVerifyMessageSignatureWithKey, 24
IMPORT DbgInitOSS, 4
IMPORT DbgPrintf
IMPORT PFXExportCertStore, 16
IMPORT PFXExportCertStoreEx, 20
IMPORT PFXImportCertStore, 12
IMPORT PFXIsPFXBlob, 4
IMPORT PFXVerifyPassword, 12

%ifdef UNICODE

%define CertAddEncodedCertificateToSystemStore CertAddEncodedCertificateToSystemStoreW
%define CertGetNameString CertGetNameStringW
%define CertNameToStr CertNameToStrW
%define CertOpenSystemStore CertOpenSystemStoreW
%define CertRDNValueToStr CertRDNValueToStrW
%define CertStrToName CertStrToNameW
%define CryptBinaryToString CryptBinaryToStringW
%define CryptStringToBinary CryptStringToBinaryW

%else  ;// ANSI

%define CertAddEncodedCertificateToSystemStore CertAddEncodedCertificateToSystemStoreA
%define CertGetNameString CertGetNameStringA
%define CertNameToStr CertNameToStrA
%define CertOpenSystemStore CertOpenSystemStoreA
%define CertRDNValueToStr CertRDNValueToStrA
%define CertStrToName CertStrToNameA
%define CryptBinaryToString CryptBinaryToStringA
%define CryptStringToBinary CryptStringToBinaryA

%endif  ;// UNICODE

%endif  ;// __NASMX_CRYPT32_INC__
