;##### Global XBOX Kernel Definitions #####
%define	XBOX_SMB_IO_BASE	0xC000
%define XBOX_SMB_GLOBAL_ENABLE	(XBOX_SMB_IO_BASE + 2)
%define XBOX_SMB_HOST_ADDRESS	(XBOX_SMB_IO_BASE + 4)
%define XBOX_SMB_HOST_DATA	(XBOX_SMB_IO_BASE + 6)
%define XBOX_SMB_HOST_COMMAND	(XBOX_SMB_IO_BASE + 8)

%define	XBOX_PIC_ADDRESS	0x10

%define SMC_CMD_POWER		0x02
%define	SMC_CMD_POWER_RESET	0x01
%define SMC_CMD_POWER_CYCLE	0x40
%define SMC_CMD_POWER_OFF	0x80

%define VIDEO_MEMORY	0xF0040000
%define	VIDEO_LIMIT	VIDEO_MEMORY+(640*480*4)

;##### Global XBOX NT Definitions #####
%define DELETE                                  0x00010000
%define SYNCHRONIZE                             0x00100000
%define GENERIC_ALL                             0x10000000
%define GENERIC_EXECUTE                         0x20000000
%define GENERIC_WRITE                           0x40000000
%define GENERIC_READ                            0x80000000

%define FILE_SHARE_READ                         0x00000001
%define FILE_SHARE_WRITE                        0x00000002
%define FILE_SHARE_DELETE                       0x00000004

%define CREATE_NEW                              0x00000001
%define CREATE_ALWAYS                           0x00000002
%define OPEN_EXISTING                           0x00000003
%define OPEN_ALWAYS                             0x00000004
%define TRUNCATE_EXISTING                       0x00000005

%define FILE_FLAG_OPEN_NO_RECALL                0x00100000
%define FILE_FLAG_OPEN_REPARSE_POINT            0x00200000
%define FILE_FLAG_POSIX_SEMANTICS               0x01000000
%define FILE_FLAG_BACKUP_SEMANTICS              0x02000000
%define FILE_FLAG_DELETE_ON_CLOSE               0x04000000
%define FILE_FLAG_SEQUENTIAL_SCAN               0x08000000
%define FILE_FLAG_RANDOM_ACCESS                 0x10000000
%define FILE_FLAG_NO_BUFFERING                  0x20000000
%define FILE_FLAG_OVERLAPPED                    0x40000000
%define FILE_FLAG_WRITE_THROUGH                 0x80000000
%define FILE_ATTRIBUTE_READONLY                 0x00000001
%define FILE_ATTRIBUTE_HIDDEN                   0x00000002
%define FILE_ATTRIBUTE_SYSTEM                   0x00000004
%define FILE_ATTRIBUTE_DIRECTORY                0x00000010
%define FILE_ATTRIBUTE_ARCHIVE                  0x00000020
%define FILE_ATTRIBUTE_DEVICE                   0x00000040
%define FILE_ATTRIBUTE_NORMAL                   0x00000080
%define FILE_ATTRIBUTE_TEMPORARY                0x00000100
%define FILE_ATTRIBUTE_SPARSE_FILE              0x00000200
%define FILE_ATTRIBUTE_REPARSE_POINT            0x00000400
%define FILE_ATTRIBUTE_COMPRESSED               0x00000800
%define FILE_ATTRIBUTE_OFFLINE                  0x00001000
%define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED      0x00002000
%define FILE_ATTRIBUTE_ENCRYPTED                0x00004000
%define FILE_ATTRIBUTE_VALID_FLAGS              0x00007fb7
%define FILE_ATTRIBUTE_VALID_SET_FLAGS          0x000031a7

%define	FILE_BEGIN                              0x00000000
%define	FILE_CURRENT                            0x00000001
%define	FILE_END                                0x00000002

%define FILE_LIST_DIRECTORY                     0x00000001
%define FILE_DIRECTORY_FILE                     0x00000001
%define FILE_WRITE_THROUGH                      0x00000002
%define FILE_SEQUENTIAL_ONLY                    0x00000004
%define FILE_NO_INTERMEDIATE_BUFFERING          0x00000008
%define FILE_SYNCHRONOUS_IO_ALERT               0x00000010
%define FILE_SYNCHRONOUS_IO_NONALERT            0x00000020
%define FILE_NON_DIRECTORY_FILE                 0x00000040
%define FILE_CREATE_TREE_CONNECTION             0x00000080
%define FILE_COMPLETE_IF_OPLOCKED               0x00000100
%define FILE_NO_EA_KNOWLEDGE                    0x00000200
%define FILE_OPEN_FOR_RECOVERY                  0x00000400
%define FILE_RANDOM_ACCESS                      0x00000800
%define FILE_DELETE_ON_CLOSE                    0x00001000
%define FILE_OPEN_BY_FILE_ID                    0x00002000
%define FILE_OPEN_FOR_BACKUP_INTENT             0x00004000
%define FILE_NO_COMPRESSION                     0x00008000
%define FILE_RESERVE_OPFILTER                   0x00100000
%define FILE_OPEN_REPARSE_POINT                 0x00200000
%define FILE_OPEN_NO_RECALL                     0x00400000
%define FILE_OPEN_FOR_FREE_SPACE_QUERY          0x00800000
%define FILE_COPY_STRUCTURED_STORAGE            0x00000041
%define FILE_STRUCTURED_STORAGE                 0x00000441
%define FILE_VALID_OPTION_FLAGS                 0x00ffffff
%define FILE_VALID_PIPE_OPTION_FLAGS            0x00000032
%define FILE_VALID_MAILSLOT_OPTION_FLAGS        0x00000032
%define FILE_VALID_SET_FLAGS                    0x00000036

%define FILE_SUPERCEDE                          0x00000000
%define FILE_OPEN                               0x00000001
%define FILE_CREATE                             0x00000002
%define FILE_OPEN_IF                            0x00000003
%define FILE_OVERWRITE                          0x00000004
%define FILE_OVERWRITE_IF                       0x00000005
%define FILE_MAXIMUM_DISPOSITION                0x00000005
%define FILE_SUPERCEDED                         0x00000000

%define FILE_OPENED                             0x00000001
%define FILE_CREATED                            0x00000002
%define FILE_OVERWRITTEN                        0x00000003
%define FILE_EXISTS                             0x00000004
%define FILE_DOES_NOT_EXIST                     0x00000005

;##### XBOX Kernel Thunk Imports #####
%define __kticall_defined_AvGetSavedDataAddress			0x80000001
%define __kticall_defined_AvSendTVEncoderOption			0x80000002
%define __kticall_defined_AvSetDisplayMode			0x80000003
%define __kticall_defined_AvSetSavedDataAddress			0x80000004
%define __kticall_defined_DbgBreakPoint				0x80000005
%define __kticall_defined_DbgBreakPointWithStatus		0x80000006
%define __kticall_defined_DbgLoadImageSymbols			0x80000007
%define __kticall_defined_DbgPrint				0x80000008
%define __kticall_defined_HalReadSMCTrayState			0x80000009
%define __kticall_defined_DbgPrompt				0x8000000A
%define __kticall_defined_DbgUnLoadImageSymbols			0x8000000B
%define __kticall_defined_ExAcquireReadWriteLockExclusive	0x8000000C
%define __kticall_defined_ExAcquireReadWriteLockShared		0x8000000D
%define __kticall_defined_ExAllocatePool			0x8000000E
%define __kticall_defined_ExAllocatePoolWithTag			0x8000000F
%define __kticall_defined_ExEventObjectType			0x80000010
%define __kticall_defined_ExFreePool				0x80000011
%define __kticall_defined_ExInitializeReadWriteLock		0x80000012
%define __kticall_defined_ExInterlockedAddLargeInteger		0x80000013
%define __kticall_defined_ExInterlockedAddLargeStatistic	0x80000014
%define __kticall_defined_ExInterlockedCompareExchange64	0x80000015
%define __kticall_defined_ExMutantObjectType			0x80000016
%define __kticall_defined_ExQueryPoolBlockSize			0x80000017
%define __kticall_defined_ExQueryNonVolatileSetting		0x80000018
%define __kticall_defined_ExReadWriteRefurbInfo			0x80000019
%define __kticall_defined_ExRaiseException			0x8000001A
%define __kticall_defined_ExRaiseStatus				0x8000001B
%define __kticall_defined_ExReleaseReadWriteLock		0x8000001C
%define __kticall_defined_ExSaveNonVolatileSetting		0x8000001D
%define __kticall_defined_ExSemaphoreObjectType			0x8000001E
%define __kticall_defined_ExTimerObjectType			0x8000001F
%define __kticall_defined_ExfInterlockedInsertHeadList		0x80000020
%define __kticall_defined_ExfInterlockedInsertTailList		0x80000021
%define __kticall_defined_ExfInterlockedRemoveHeadList		0x80000022
%define __kticall_defined_FscGetCacheSize			0x80000023
%define __kticall_defined_FscInvalidateIdleBlocks		0x80000024
%define __kticall_defined_FscSetCacheSize			0x80000025
%define __kticall_defined_HalClearSoftwareInterrupt		0x80000026
%define __kticall_defined_HalDisableSystemInterrupt		0x80000027
%define __kticall_defined_HalDiskCachePartitionCount		0x80000028
%define __kticall_defined_HalDiskModelNumber			0x80000029
%define __kticall_defined_HalDiskSerialNumber			0x8000002A
%define __kticall_defined_HalEnableSystemInterrupt		0x8000002B
%define __kticall_defined_HalGetInterruptVector			0x8000002C
%define __kticall_defined_HalReadSMBusValue			0x8000002D
%define __kticall_defined_HalReadWritePCISpace			0x8000002E
%define __kticall_defined_HalRegisterShutdownNotification	0x8000002F
%define __kticall_defined_HalRequestSoftwareInterrupt		0x80000030
%define __kticall_defined_HalReturnToFirmware			0x80000031
%define __kticall_defined_HalWriteSMBusValue			0x80000032
%define __kticall_defined_InterlockedCompareExchange		0x80000033
%define __kticall_defined_InterlockedDecrement			0x80000034
%define __kticall_defined_InterlockedIncrement			0x80000035
%define __kticall_defined_InterlockedExchange			0x80000036
%define __kticall_defined_InterlockedExchangeAdd		0x80000037
%define __kticall_defined_InterlockedFlushSList			0x80000038
%define __kticall_defined_InterlockedPopEntrySList		0x80000039
%define __kticall_defined_InterlockedPushEntrySList		0x8000003A
%define __kticall_defined_IoAllocateIrp				0x8000003B
%define __kticall_defined_IoBuildAsynchronousFsdRequest		0x8000003C
%define __kticall_defined_IoBuildDeviceIoControlRequest		0x8000003D
%define __kticall_defined_IoBuildSynchronousFsdRequest		0x8000003E
%define __kticall_defined_IoCheckShareAccess			0x8000003F
%define __kticall_defined_IoCompletionObjectType		0x80000040
%define __kticall_defined_IoCreateDevice			0x80000041
%define __kticall_defined_IoCreateFile				0x80000042
%define __kticall_defined_IoCreateSymbolicLink			0x80000043
%define __kticall_defined_IoDeleteDevice			0x80000044
%define __kticall_defined_IoDeleteSymbolicLink			0x80000045
%define __kticall_defined_IoDeviceObjectType			0x80000046
%define __kticall_defined_IoFileObjectType			0x80000047
%define __kticall_defined_IoFreeIrp				0x80000048
%define __kticall_defined_IoInitializeIrp			0x80000049
%define __kticall_defined_IoInvalidDeviceRequest		0x8000004A
%define __kticall_defined_IoQueryFileInformation		0x8000004B
%define __kticall_defined_IoQueryVolumeInformation		0x8000004C
%define __kticall_defined_IoQueueThreadIrp			0x8000004D
%define __kticall_defined_IoRemoveShareAccess			0x8000004E
%define __kticall_defined_IoSetIoCompletion			0x8000004F
%define __kticall_defined_IoSetShareAccess			0x80000050
%define __kticall_defined_IoStartNextPacket			0x80000051
%define __kticall_defined_IoStartNextPacketByKey		0x80000052
%define __kticall_defined_IoStartPacket				0x80000053
%define __kticall_defined_IoSynchronousDeviceIoControlRequest	0x80000054
%define __kticall_defined_IoSynchronousFsdRequest		0x80000055
%define __kticall_defined_IofCallDriver				0x80000056
%define __kticall_defined_IofCompleteRequest			0x80000057
%define __kticall_defined_KdDebuggerEnabled			0x80000058
%define __kticall_defined_KdDebuggerNotPresent			0x80000059
%define __kticall_defined_IoDismountVolume			0x8000005A
%define __kticall_defined_IoDismountVolumeByName		0x8000005B
%define __kticall_defined_KeAlertResumeThread			0x8000005C
%define __kticall_defined_KeAlertThread				0x8000005D
%define __kticall_defined_KeBoostPriorityThread			0x8000005E
%define __kticall_defined_KeBugCheck				0x8000005F
%define __kticall_defined_KeBugCheckEx				0x80000060
%define __kticall_defined_KeCancelTimer				0x80000061
%define __kticall_defined_KeConnectInterrupt			0x80000062
%define __kticall_defined_KeDelayExecutionThread		0x80000063
%define __kticall_defined_KeDisconnectInterrupt			0x80000064
%define __kticall_defined_KeEnterCriticalRegion			0x80000065
%define __kticall_defined_MmGlobalData				0x80000066
%define __kticall_defined_KeGetCurrentIrql			0x80000067
%define __kticall_defined_KeGetCurrentThread			0x80000068
%define __kticall_defined_KeInitializeApc			0x80000069
%define __kticall_defined_KeInitializeDeviceQueue		0x8000006A
%define __kticall_defined_KeInitializeDpc			0x8000006B
%define __kticall_defined_KeInitializeEvent			0x8000006C
%define __kticall_defined_KeInitializeInterrupt			0x8000006D
%define __kticall_defined_KeInitializeMutant			0x8000006E
%define __kticall_defined_KeInitializeQueue			0x8000006F
%define __kticall_defined_KeInitializeSemaphore			0x80000070
%define __kticall_defined_KeInitializeTimerEx			0x80000071
%define __kticall_defined_KeInsertByKeyDeviceQueue		0x80000072
%define __kticall_defined_KeInsertDeviceQueue			0x80000073
%define __kticall_defined_KeInsertHeadQueue			0x80000074
%define __kticall_defined_KeInsertQueue				0x80000075
%define __kticall_defined_KeInsertQueueApc			0x80000076
%define __kticall_defined_KeInsertQueueDpc			0x80000077
%define __kticall_defined_KeInterruptTime			0x80000078
%define __kticall_defined_KeIsExecutingDpc			0x80000079
%define __kticall_defined_KeLeaveCriticalRegion			0x8000007A
%define __kticall_defined_KePulseEvent				0x8000007B
%define __kticall_defined_KeQueryBasePriorityThread		0x8000007C
%define __kticall_defined_KeQueryInterruptTime			0x8000007D
%define __kticall_defined_KeQueryPerformanceCounter		0x8000007E
%define __kticall_defined_KeQueryPerformanceFrequency		0x8000007F
%define __kticall_defined_KeQuerySystemTime			0x80000080
%define __kticall_defined_KeRaiseIrqlToDpcLevel			0x80000081
%define __kticall_defined_KeRaiseIrqlToSynchLevel		0x80000082
%define __kticall_defined_KeReleaseMutant			0x80000083
%define __kticall_defined_KeReleaseSemaphore			0x80000084
%define __kticall_defined_KeRemoveByKeyDeviceQueue		0x80000085
%define __kticall_defined_KeRemoveDeviceQueue			0x80000086
%define __kticall_defined_KeRemoveEntryDeviceQueue		0x80000087
%define __kticall_defined_KeRemoveQueue				0x80000088
%define __kticall_defined_KeRemoveQueueDpc			0x80000089
%define __kticall_defined_KeResetEvent				0x8000008A
%define __kticall_defined_KeRestoreFloatingPointState		0x8000008B
%define __kticall_defined_KeResumeThread			0x8000008C
%define __kticall_defined_KeRundownQueue			0x8000008D
%define __kticall_defined_KeSaveFloatingPointState		0x8000008E
%define __kticall_defined_KeSetBasePriorityThread		0x8000008F
%define __kticall_defined_KeSetDisableBoostThread		0x80000090
%define __kticall_defined_KeSetEvent				0x80000091
%define __kticall_defined_KeSetEventBoostPriority		0x80000092
%define __kticall_defined_KeSetPriorityProcess			0x80000093
%define __kticall_defined_KeSetPriorityThread			0x80000094
%define __kticall_defined_KeSetTimer				0x80000095
%define __kticall_defined_KeSetTimerEx				0x80000096
%define __kticall_defined_KeStallExecutionProcessor		0x80000097
%define __kticall_defined_KeSuspendThread			0x80000098
%define __kticall_defined_KeSynchronizeExecution		0x80000099
%define __kticall_defined_KeSystemTime				0x8000009A
%define __kticall_defined_KeTestAlertThread			0x8000009B
%define __kticall_defined_KeTickCount				0x8000009C
%define __kticall_defined_KeTimeIncrement			0x8000009D
%define __kticall_defined_KeWaitForMultipleObjects		0x8000009E
%define __kticall_defined_KeWaitForSingleObject			0x8000009F
%define __kticall_defined_KfRaiseIrql				0x800000A0
%define __kticall_defined_KfLowerIrql				0x800000A1
%define __kticall_defined_KiBugCheckData			0x800000A2
%define __kticall_defined_KiUnlockDispatcherDatabase		0x800000A3
%define __kticall_defined_LaunchDataPage			0x800000A4
%define __kticall_defined_MmAllocateContiguousMemory		0x800000A5
%define __kticall_defined_MmAllocateContiguousMemoryEx		0x800000A6
%define __kticall_defined_MmAllocateSystemMemory		0x800000A7
%define __kticall_defined_MmClaimGpuInstanceMemory		0x800000A8
%define __kticall_defined_MmCreateKernelStack			0x800000A9
%define __kticall_defined_MmDeleteKernelStack			0x800000AA
%define __kticall_defined_MmFreeContiguousMemory		0x800000AB
%define __kticall_defined_MmFreeSystemMemory			0x800000AC
%define __kticall_defined_MmGetPhysicalAddress			0x800000AD
%define __kticall_defined_MmIsAddressValid			0x800000AE
%define __kticall_defined_MmLockUnlockBufferPages		0x800000AF
%define __kticall_defined_MmLockUnlockPhysicalPage		0x800000B0
%define __kticall_defined_MmMapIoSpace				0x800000B1
%define __kticall_defined_MmPersistContiguousMemory		0x800000B2
%define __kticall_defined_MmQueryAddressProtect			0x800000B3
%define __kticall_defined_MmQueryAllocationSize			0x800000B4
%define __kticall_defined_MmQueryStatistics			0x800000B5
%define __kticall_defined_MmSetAddressProtect			0x800000B6
%define __kticall_defined_MmUnmapIoSpace			0x800000B7
%define __kticall_defined_NtAllocateVirtualMemory		0x800000B8
%define __kticall_defined_NtCancelTimer				0x800000B9
%define __kticall_defined_NtClearEvent				0x800000BA
%define __kticall_defined_NtClose				0x800000BB
%define __kticall_defined_NtCreateDirectoryObject		0x800000BC
%define __kticall_defined_NtCreateEvent				0x800000BD
%define __kticall_defined_NtCreateFile				0x800000BE
%define __kticall_defined_NtCreateIoCompletion			0x800000BF
%define __kticall_defined_NtCreateMutant			0x800000C0
%define __kticall_defined_NtCreateSemaphore			0x800000C1
%define __kticall_defined_NtCreateTimer				0x800000C2
%define __kticall_defined_NtDeleteFile				0x800000C3
%define __kticall_defined_NtDeviceIoControlFile			0x800000C4
%define __kticall_defined_NtDuplicateObject			0x800000C5
%define __kticall_defined_NtFlushBuffersFile			0x800000C6
%define __kticall_defined_NtFreeVirtualMemory			0x800000C7
%define __kticall_defined_NtFsControlFile			0x800000C8
%define __kticall_defined_NtOpenDirectoryObject			0x800000C9
%define __kticall_defined_NtOpenFile				0x800000CA
%define __kticall_defined_NtOpenSymbolicLinkObject		0x800000CB
%define __kticall_defined_NtProtectVirtualMemory		0x800000CC
%define __kticall_defined_NtPulseEvent				0x800000CD
%define __kticall_defined_NtQueueApcThread			0x800000CE
%define __kticall_defined_NtQueryDirectoryFile			0x800000CF
%define __kticall_defined_NtQueryDirectoryObject		0x800000D0
%define __kticall_defined_NtQueryEvent				0x800000D1
%define __kticall_defined_NtQueryFullAttributesFile		0x800000D2
%define __kticall_defined_NtQueryInformationFile		0x800000D3
%define __kticall_defined_NtQueryIoCompletion			0x800000D4
%define __kticall_defined_NtQueryMutant				0x800000D5
%define __kticall_defined_NtQuerySemaphore			0x800000D6
%define __kticall_defined_NtQuerySymbolicLinkObject		0x800000D7
%define __kticall_defined_NtQueryTimer				0x800000D8
%define __kticall_defined_NtQueryVirtualMemory			0x800000D9
%define __kticall_defined_NtQueryVolumeInformationFile		0x800000DA
%define __kticall_defined_NtReadFile				0x800000DB
%define __kticall_defined_NtReadFileScatter			0x800000DC
%define __kticall_defined_NtReleaseMutant			0x800000DD
%define __kticall_defined_NtReleaseSemaphore			0x800000DE
%define __kticall_defined_NtRemoveIoCompletion			0x800000DF
%define __kticall_defined_NtResumeThread			0x800000E0
%define __kticall_defined_NtSetEvent				0x800000E1
%define __kticall_defined_NtSetInformationFile			0x800000E2
%define __kticall_defined_NtSetIoCompletion			0x800000E3
%define __kticall_defined_NtSetSystemTime			0x800000E4
%define __kticall_defined_NtSetTimerEx				0x800000E5
%define __kticall_defined_NtSignalAndWaitForSingleObjectEx	0x800000E6
%define __kticall_defined_NtSuspendThread			0x800000E7
%define __kticall_defined_NtUserIoApcDispatcher			0x800000E8
%define __kticall_defined_NtWaitForSingleObject			0x800000E9
%define __kticall_defined_NtWaitForSingleObjectEx		0x800000EA
%define __kticall_defined_NtWaitForMultipleObjectsEx		0x800000EB
%define __kticall_defined_NtWriteFile				0x800000EC
%define __kticall_defined_NtWriteFileGather			0x800000ED
%define __kticall_defined_NtYieldExecution			0x800000EE
%define __kticall_defined_ObCreateObject			0x800000EF
%define __kticall_defined_ObDirectoryObjectType			0x800000F0
%define __kticall_defined_ObInsertObject			0x800000F1
%define __kticall_defined_ObMakeTemporaryObject			0x800000F2
%define __kticall_defined_ObOpenObjectByName			0x800000F3
%define __kticall_defined_ObOpenObjectByPointer			0x800000F4
%define __kticall_defined_ObpObjectHandleTable			0x800000F5
%define __kticall_defined_ObReferenceObjectByHandle		0x800000F6
%define __kticall_defined_ObReferenceObjectByName		0x800000F7
%define __kticall_defined_ObReferenceObjectByPointer		0x800000F8
%define __kticall_defined_ObSymbolicLinkObjectType		0x800000F9
%define __kticall_defined_ObfDereferenceObject			0x800000FA
%define __kticall_defined_ObfReferenceObject			0x800000FB
%define __kticall_defined_PhyGetLinkState			0x800000FC
%define __kticall_defined_PhyInitialize				0x800000FD
%define __kticall_defined_PsCreateSystemThread			0x800000FE
%define __kticall_defined_PsCreateSystemThreadEx		0x800000FF
%define __kticall_defined_PsQueryStatistics			0x80000100
%define __kticall_defined_PsSetCreateThreadNotifyRoutine	0x80000101
%define __kticall_defined_PsTerminateSystemThread		0x80000102
%define __kticall_defined_PsThreadObjectType			0x80000103
%define __kticall_defined_RtlAnsiStringToUnicodeString		0x80000104
%define __kticall_defined_RtlAppendStringToString		0x80000105
%define __kticall_defined_RtlAppendUnicodeStringToString	0x80000106
%define __kticall_defined_RtlAppendUnicodeToString		0x80000107
%define __kticall_defined_RtlAssert				0x80000108
%define __kticall_defined_RtlCaptureContext			0x80000109
%define __kticall_defined_RtlCaptureStackBackTrace		0x8000010A
%define __kticall_defined_RtlCharToInteger			0x8000010B
%define __kticall_defined_RtlCompareMemory			0x8000010C
%define __kticall_defined_RtlCompareMemoryUlong			0x8000010D
%define __kticall_defined_RtlCompareString			0x8000010E
%define __kticall_defined_RtlCompareUnicodeString		0x8000010F
%define __kticall_defined_RtlCopyString				0x80000110
%define __kticall_defined_RtlCopyUnicodeString			0x80000111
%define __kticall_defined_RtlCreateUnicodeString		0x80000112
%define __kticall_defined_RtlDowncaseUnicodeChar		0x80000113
%define __kticall_defined_RtlDowncaseUnicodeString		0x80000114
%define __kticall_defined_RtlEnterCriticalSection		0x80000115
%define __kticall_defined_RtlEnterCriticalSectionAndRegion	0x80000116
%define __kticall_defined_RtlEqualString			0x80000117
%define __kticall_defined_RtlEqualUnicodeString			0x80000118
%define __kticall_defined_RtlExtendedIntegerMultiply		0x80000119
%define __kticall_defined_RtlExtendedLargeIntegerDivide		0x8000011A
%define __kticall_defined_RtlExtendedMagicDivide		0x8000011B
%define __kticall_defined_RtlFillMemory				0x8000011C
%define __kticall_defined_RtlFillMemoryUlong			0x8000011D
%define __kticall_defined_RtlFreeAnsiString			0x8000011E
%define __kticall_defined_RtlFreeUnicodeString			0x8000011F
%define __kticall_defined_RtlGetCallersAddress			0x80000120
%define __kticall_defined_RtlInitAnsiString			0x80000121
%define __kticall_defined_RtlInitUnicodeString			0x80000122
%define __kticall_defined_RtlInitializeCriticalSection		0x80000123
%define __kticall_defined_RtlIntegerToChar			0x80000124
%define __kticall_defined_RtlIntegerToUnicodeString		0x80000125
%define __kticall_defined_RtlLeaveCriticalSection		0x80000126
%define __kticall_defined_RtlLeaveCriticalSectionAndRegion	0x80000127
%define __kticall_defined_RtlLowerChar				0x80000128
%define __kticall_defined_RtlMapGenericMask			0x80000129
%define __kticall_defined_RtlMoveMemory				0x8000012A
%define __kticall_defined_RtlMultiByteToUnicodeN		0x8000012B
%define __kticall_defined_RtlMultiByteToUnicodeSize		0x8000012C
%define __kticall_defined_RtlNtStatusToDosError			0x8000012D
%define __kticall_defined_RtlRaiseException			0x8000012E
%define __kticall_defined_RtlRaiseStatus			0x8000012F
%define __kticall_defined_RtlTimeFieldsToTime			0x80000130
%define __kticall_defined_RtlTimeToTimeFields			0x80000131
%define __kticall_defined_RtlTryEnterCriticalSection		0x80000132
%define __kticall_defined_RtlUlongByteSwap			0x80000133
%define __kticall_defined_RtlUnicodeStringToAnsiString		0x80000134
%define __kticall_defined_RtlUnicodeStringToInteger		0x80000135
%define __kticall_defined_RtlUnicodeToMultiByteN		0x80000136
%define __kticall_defined_RtlUnicodeToMultiByteSize		0x80000137
%define __kticall_defined_RtlUnwind				0x80000138
%define __kticall_defined_RtlUpcaseUnicodeChar			0x80000139
%define __kticall_defined_RtlUpcaseUnicodeString		0x8000013A
%define __kticall_defined_RtlUpcaseUnicodeToMultiByteN		0x8000013B
%define __kticall_defined_RtlUpperChar				0x8000013C
%define __kticall_defined_RtlUpperString			0x8000013D
%define __kticall_defined_RtlUshortByteSwap			0x8000013E
%define __kticall_defined_RtlWalkFrameChain			0x8000013F
%define __kticall_defined_RtlZeroMemory				0x80000140
%define __kticall_defined_XboxEEPROMKey				0x80000141
%define __kticall_defined_XboxHardwareInfo			0x80000142
%define __kticall_defined_XboxHDKey				0x80000143
%define __kticall_defined_XboxKrnlVersion			0x80000144
%define __kticall_defined_XboxSignatureKey			0x80000145
%define __kticall_defined_XeImageFileName			0x80000146
%define __kticall_defined_XeLoadSection				0x80000147
%define __kticall_defined_XeUnloadSection			0x80000148
%define __kticall_defined_READ_PORT_BUFFER_UCHAR		0x80000149
%define __kticall_defined_READ_PORT_BUFFER_USHORT		0x8000014A
%define __kticall_defined_READ_PORT_BUFFER_ULONG		0x8000014B
%define __kticall_defined_WRITE_PORT_BUFFER_UCHAR		0x8000014C
%define __kticall_defined_WRITE_PORT_BUFFER_USHORT		0x8000014D
%define __kticall_defined_WRITE_PORT_BUFFER_ULONG		0x8000014E
%define __kticall_defined_XcSHAInit				0x8000014F
%define __kticall_defined_XcSHAUpdate				0x80000150
%define __kticall_defined_XcSHAFinal				0x80000151
%define __kticall_defined_XcRC4Key				0x80000152
%define __kticall_defined_XcRC4Crypt				0x80000153
%define __kticall_defined_XcHMAC				0x80000154
%define __kticall_defined_XcPKEncPublic				0x80000155
%define __kticall_defined_XcPKDecPrivate			0x80000156
%define __kticall_defined_XcPKGetKeyLen				0x80000157
%define __kticall_defined_XcVerifyPKCS1Signature		0x80000158
%define __kticall_defined_XcModExp				0x80000159
%define __kticall_defined_XcDESKeyParity			0x8000015A
%define __kticall_defined_XcKeyTable				0x8000015B
%define __kticall_defined_XcBlockCrypt				0x8000015C
%define __kticall_defined_XcBlockCryptCBC			0x8000015D
%define __kticall_defined_XcCryptService			0x8000015E
%define __kticall_defined_XcUpdateCrypto			0x8000015F
%define __kticall_defined_RtlRip				0x80000160
%define __kticall_defined_XboxLANKey				0x80000161
%define __kticall_defined_XboxAlternateSignatureKeys		0x80000162
%define __kticall_defined_XePublicKeyData			0x80000163
%define __kticall_defined_HalBootSMCVideoMode			0x80000164
%define __kticall_defined_IdexChannelObject			0x80000165
%define __kticall_defined_HalIsResetOrShutdownPending		0x80000166
%define __kticall_defined_IoMarkIrpMustComplete			0x80000167
%define __kticall_defined_HalInitiateShutdown			0x80000168
%define __kticall_defined_snprintf				0x80000169
%define __kticall_defined_sprintf				0x8000016A
%define __kticall_defined_vsnprintf				0x8000016B
%define __kticall_defined_vsprintf				0x8000016C
%define __kticall_defined_HalEnableSecureTrayEject		0x8000016D
%define __kticall_defined_HalWriteSMCScratchRegister		0x8000016E

